# Grammar2Uml

The tool called `Grammar2Uml` ([see in repo](https://git-st.inf.tu-dresden.de/jastadd/relast2uml/-/tree/master/grammar2uml)) takes a set of grammar specifications and creates a visualization similar to UML class diagrams.

![](_static/grammar2uml.png)
![](_static/minimal-example.png)

Every nonterminal will be shown as a rectangular box with its terminal children listed within it. Children are shown as containment relations between parent and child, whereas relations and intrinsic references are shown using arrows.

Furthermore, some options may be specified.

|         Name         | Required (Default) |                               Description                               |
|----------------------|--------------------|-------------------------------------------------------------------------|
| `--output`           | No (`uml.md`)      | target file to be generated.                                            |
| `--inputGrammar2Uml` | No                 | grammar2uml definition file, see [below](#grammar2uml-definition-file). |
| `--defaultFolders`   | No (`false`)       | Creates a default folder per grammar file.                              |
| `--help`             | No                 | Print usage and exit.                                                   |
| `--version`          | No                 | Print version and exit.                                                 |
| `--verbose`          | No                 | Print more messages while compiling.                                    |

## Grammar2uml definition file

To structure the generated visualization, any number of nonterminals can be grouped with folders.
Either specify the option `--defaultFolders` to use one folder per input grammar file, or specify a grammar2uml definition file.
The definition file has a simple syntax, it is a list of folder specifications. One specifications looks like

```
folder FOLDER_NAME : NT1, NT2, ..., NT_n
```

It produces one folder named `FOLDER_NAME` containing all nonterminals (`NT1`, `NT2`, ..., `NT_n`) following it.
