package de.tudresden.inf.st.jastadd.testDumper;

import org.jastadd.testDumper.ast.A;
import org.jastadd.testDumper.ast.B;
import org.jastadd.testDumper.ast.C;
import org.jastadd.testDumper.ast.Root;

public class TestDumperMain {
  public static void main(String[] args) {
    Root root = new Root();
    root.setName("Root1");
    A a = new A();
    a.setName("A2");
    B b1 = new B();
    b1.setName("B3");
    C c = new C();
    c.setName("C4");
    c.setRawReference(a);
    b1.setOneA(a);
    B b2 = new B();
    b2.setName("B5");
    C myC = new C();
    myC.setName("C6");
    a.setMyC(myC);
    root.setA(a);
    root.addB(b1);
    root.addB(b2);
    root.setC(c);

    TestUtils.ExposingDumpBuilder builder = new TestUtils.ExposingDumpBuilder(root);
    builder.includeAttributes("simpleAttr")
        .includeNonterminalAttributes("getCalculated");

    System.out.println(">> PlantUml");
    System.out.println(builder.build().toPlantUml());

    System.out.println(">> YAML begin");
    System.out.println(builder.build().toYaml(true));
    System.out.println(">> YAML end");
  }
}
